Index: s390-tools-sles11/zipl/boot/tapedump.S
===================================================================
--- s390-tools-sles11.orig/zipl/boot/tapedump.S
+++ s390-tools-sles11/zipl/boot/tapedump.S
@@ -44,8 +44,7 @@
 
 #define ETAPE_REWUNL_1  0x00000001
 #define ETAPE_REWUNL_2  0x00000002
-#define ETAPE_REWUNL_3  0x00000004
-#define ETAPE_WRITE     0x00000003
+#define ETAPE_WRITE     0x0003
 
 /* Tape types */
 
@@ -264,9 +263,8 @@ _writer_64:        
 
         la    %r7,.Lccwwrite-0b(%r13)
         st    %r7,8+.Lorbwrite-0b(%r13)
-        llgf  %r7,.Luse_idrc-0b(%r13)
-        lghi  %r9,1
-        clr   %r7,%r9
+        lh    %r7,.Luse_idrc-0b(%r13)
+        chi   %r7,1
         bne   .Lnocomp-0b(%r13)
         la    %r7,.Lccwwrite_compressed-0b(%r13)
         st    %r7,8+.Lorbwrite-0b(%r13)
@@ -308,8 +306,7 @@ _writer_64:        
         lghi  %r2,0
         ic    %r2,.Ltmp_data+3-0b(%r13)      # get ERA
         sll   %r2,24                           # move it to first byte
-        lghi  %r3,ETAPE_WRITE
-        ar    %r2,%r3
+        ahi   %r2,ETAPE_WRITE
 
         llgf  %r14,.Lpanik_64-0b(%r13)
         basr  %r14,%r14
@@ -407,13 +404,11 @@ _rewind_unload_64:
 
 	/* check for 3590 */
 
-	l     %r9,.Ltape_type-0b(%r13)
-	lghi  %r10,TAPE_3590
-	clr   %r9,%r10
+	lh    %r9,.Ltape_type-0b(%r13)
+	chi   %r9,TAPE_3590
 	bne   .Lnot3590-0b(%r13)
 
-	la    %r4,.Lirb-0b(%r13)
-	tm    8(%r4),0x2                       # unit check ?
+	tm    .Lirb+8-0b(%r13),0x2             # unit check?
 	bz    3f-0b(%r13)                      # no unit check: rewunl worked
 
         /* 3590: retry rewind unload */
@@ -438,15 +433,13 @@ _rewind_unload_64:
         lghi  %r5,1
         bas   %r14,_ssch_64-0b(%r13)
 
-        lghi  %r9,0
-        ic    %r9,.Ltmp_data+3-0b(%r13)      # load sense byte 3
-        lghi  %r10,0x2b                        # 3480: ERA: rewunl compl (2b)
-        clr   %r9,%r10
+	cli   .Ltmp_data+3-0b(%r13),0x2b     # check load sense byte 3
+	                                     # 3480: ERA: rewunl completed (2b)
         be    3f-0b(%r13)
 
-        lghi  %r10,0x51                        # 3490: ERA: EOV (51)
         lghi  %r2,ETAPE_REWUNL_1
-        clr   %r9,%r10
+	cli   .Ltmp_data+3-0b(%r13),0x51     # check load sense byte 3
+	                                     # 3490: ERA: EOV (51)
         bne   2f-0b(%r13)
 
         /* 3490: retry rewind unload */
@@ -465,10 +458,8 @@ _rewind_unload_64:
         lghi  %r5,1
         bas   %r14,_ssch_64-0b(%r13)
 
-        lghi  %r9,0
-        ic    %r9,.Ltmp_data+3-0b(%r13)  # load sense byte 3
-        lghi  %r10,0x52                    # 3490: ERA: EOV Complete (52)
-        clr   %r9,%r10
+	cli   .Ltmp_data+3-0b(%r13),0x52     # check load sense byte 3
+	                                     # 3490: ERA: EOV Complete (52)
         be    3f-0b(%r13)
 
         lghi  %r2,ETAPE_REWUNL_2
@@ -491,10 +482,7 @@ _rewind_unload_64:
         llgf  %r2,IPL_SC
         la    %r3,.Lirb-0b(%r13)
         bas   %r14,_wait4de_64-0b(%r13)
-	lghi  %r9,0
-	ic    %r9,.Lirb+8-0b(%r13)        # get device state
-	lghi  %r10,0x85
-	clr   %r9,%r10
+	cli   .Lirb+8-0b(%r13),0x85
 	bne   .Lwait_loop-0b(%r13)
 
 4:      lmg   %r6,%r15,248(%r15)
@@ -549,8 +537,8 @@ _get_device_characteristics_64:
 	lhi     %r6,TAPE_UNKNOWN
 	lhi     %r7,0                   # idrc off
 1:
-	st	%r6,.Ltape_type-0b(%r13)
-	st      %r7,.Luse_idrc-0b(%r13)
+	sth     %r6,.Ltape_type-0b(%r13)
+	sth     %r7,.Luse_idrc-0b(%r13)
 	lmg	%r6,%r15,248(%r15)
         br	%r14
 
@@ -680,7 +668,7 @@ _start: basr   %r13,0
 _dump_mem_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                         # base register
-0:      s      %r15,.Lc96-0b(%r13)            # create stack frame
+0:      ahi    %r15,-96                       # create stack frame
 
 #
 # first write a tape mark
@@ -760,7 +748,7 @@ _dump_mem_32:
 _init_tape_32:
         stm   %r6,%r15,24(%r15)
         basr  %r13,0                           # base register
-0:      s     %r15,.Lc96-0b(%r13)              # create stack frame
+0:      ahi   %r15,-96                         # create stack frame
 
         l     %r2,IPL_SC                       # subchannel id
         la    %r3,.Lorbmode_set-0b(%r13)
@@ -785,7 +773,7 @@ _init_tape_32:
 _next_vol_32:
         stm   %r6,%r15,24(%r15)
         basr  %r13,0                           # base register
-0:      s     %r15,.Lc96-0b(%r13)              # create stack frame
+0:      ahi   %r15,-96                         # create stack frame
 
         /* write end of volume marker */
         la    %r2,.Leov_marker-0b(%r13)
@@ -833,7 +821,7 @@ _next_vol_32:
 _writer_32:        
         stm   %r6,%r15,24(%r15)
         basr  %r13,0                           # base register
-0:      s     %r15,.Lc96-0b(%r13)              # create stack frame
+0:      ahi   %r15,-96                         # create stack frame
 
         lr    %r10,%r2                         # save start address
         lr    %r11,%r3                         # save length
@@ -845,9 +833,8 @@ _writer_32:        
 
 	la    %r7,.Lccwwrite-0b(%r13)
 	st    %r7,8+.Lorbwrite-0b(%r13)
-	l     %r7,.Luse_idrc-0b(%r13)
-	la    %r9,1
-	clr   %r7,%r9
+	lh    %r7,.Luse_idrc-0b(%r13)
+	chi   %r7,1
 	bne   .Lnocomp-0b(%r13)
 	la    %r7,.Lccwwrite_compressed-0b(%r13)
         st    %r7,8+.Lorbwrite-0b(%r13)
@@ -888,8 +875,7 @@ _writer_32:        
         la    %r2,0 
         ic    %r2,.Ltmp_data+3-0b(%r13)      # get ERA
         sll   %r2,24                           # move it to first byte 
-        la    %r3,ETAPE_WRITE
-        ar    %r2,%r3
+        ahi   %r2,ETAPE_WRITE
  
         l     %r14,.Lpanik_32-0b(%r13)
         basr  %r14,%r14
@@ -957,7 +943,7 @@ _writer_32:        
 _hex_to_ebcdic_32:
         stm  %r6,%r15,24(%r15)
         basr  %r13,0                           # base register
-0:      s     %r15,.Lc96-0b(%r13)              # create stack frame
+0:      ahi   %r15,-96                         # create stack frame
         cvd   %r2,.Lout_packed-0b(%r13)        # convert to packed decimal
         unpk  0(8,%r3),.Lout_packed+4-0b(4,%r13) 
         oi    7(%r3),0xf0                      # remove signed flag
@@ -974,7 +960,7 @@ _hex_to_ebcdic_32:
 _rewind_unload_32:
         stm  %r6,%r15,24(%r15)
         basr  %r13,0                           # base register
-0:      s     %r15,.Lc96-0b(%r13)              # create stack frame
+0:      ahi   %r15,-96                         # create stack frame
 
         /* 3480/3490: rewind unload */
 
@@ -992,15 +978,13 @@ _rewind_unload_32:
         la    %r5,1
         bas   %r14,_ssch_32-0b(%r13)
 
-        la    %r9,0
-        ic    %r9,.Ltmp_data+3-0b(%r13)      # load sense byte 3
-        la    %r10,0x2b                        # 3480: ERA: rewunl completed (2b)
-        clr   %r9,%r10
+	cli   .Ltmp_data+3-0b(%r13),0x2b     # check load sense byte 3
+	                                     # 3480: ERA: rewunl completed (2b)
         be    3f-0b(%r13)
  
-        la    %r10,0x51                        # 3490: ERA: EOV (51)  
         la    %r2,ETAPE_REWUNL_1
-        clr   %r9,%r10
+	cli   .Ltmp_data+3-0b(%r13),0x51     # check load sense byte 3
+	                                     # 3490: ERA: EOV (51)
         bne   2f-0b(%r13)
 
         /* 3490: retry rewind unload */
@@ -1019,10 +1003,8 @@ _rewind_unload_32:
         la    %r5,1
         bas   %r14,_ssch_32-0b(%r13)
 
-        la    %r9,0
-        ic    %r9,.Ltmp_data+3-0b(%r13)  # load sense byte 3
-        la    %r10,0x52                    # 3490: ERA: EOV Complete (52)
-        clr   %r9,%r10
+	cli   .Ltmp_data+3-0b(%r13),0x52     # check load sense byte 3
+	                                     # 3490: ERA: EOV Complete (52)
         be    3f-0b(%r13)
  
         la    %r2,ETAPE_REWUNL_2
@@ -1069,7 +1051,7 @@ _rewind_unload_32:
 _get_device_characteristics_32:
 	stm    %r6,%r15,24(%r15)
         basr   %r13,0                   # base register
-0:      s      %r15,.Lc96-0b(%r13)      # create stack frame
+0:      ahi    %r15,-96                 # create stack frame
         l      %r2,IPL_SC
         la     %r3,.Lorb_read_cc-0b(%r13)
         la     %r4,.Lirb-0b(%r13)
@@ -1096,8 +1078,8 @@ _get_device_characteristics_32:
         la      %r6,TAPE_UNKNOWN
 	la      %r7,0                   # idrc off
 1:
-        st      %r6,.Ltape_type-0b(%r13)
-	st      %r7,.Luse_idrc-0b(%r13)
+        sth     %r6,.Ltape_type-0b(%r13)
+	sth     %r7,.Luse_idrc-0b(%r13)
 	lm      %r6,%r15,120(%r15)
         br      %r14
  
@@ -1122,7 +1104,7 @@ _get_device_characteristics_32:
 _load_display_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                         # base register
-0:      s      %r15,.Lc96-0b(%r13)            # create stack frame
+0:      ahi    %r15,-96                       # create stack frame
         st    %r2,.Lccwload_disp+4-0b(%r13)   # store text field
         l     %r2,IPL_SC                      # subchannel id
         la    %r3,.Lorbload_disp-0b(%r13)     # address of orb
@@ -1147,7 +1129,7 @@ _load_display_32:
 _tapemark_32:
         stm   %r6,%r15,24(%r15)
         basr  %r13,0                           # base register
-0:      s     %r15,.Lc96-0b(%r13)              # create stack frame
+0:      ahi   %r15,-96                         # create stack frame
 
         l     %r2,IPL_SC                       # subchannel id
         la    %r3,.Lorbmark-0b(%r13)           # r3 = address of orb
@@ -1195,12 +1177,11 @@ _tapemark_32:
 # DATA
 ################################################################################
 
-.Ltape_type: .long 0 /* 3480/90 3590 etc. */
-.Luse_idrc:  .long 1 /* 1 -> use idrc compression */
+.Ltape_type: .word 0 /* 3480/90 3590 etc. */
+.Luse_idrc:  .word 1 /* 1 -> use idrc compression */
                      /* 0 -> do not use idrc (e.g. for 3480 not allowed) */
 
 .Lirb:  .long  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
-.Lc96:  .long  96 # for creating stackframes
 .org IPL_BS-8
 .Lmem_upper_limit:
         .long 0xffffffff,0xffffffff              # can be used for memsize=xxx
Index: s390-tools-sles11/zipl/include/disk.h
===================================================================
--- s390-tools-sles11.orig/zipl/include/disk.h
+++ s390-tools-sles11/zipl/include/disk.h
@@ -79,6 +79,7 @@ int disk_get_info(const char* device, st
 int disk_get_info_from_file(const char* filename, struct disk_info** info);
 void disk_free_info(struct disk_info* info);
 char* disk_get_type_name(disk_type_t type);
+int disk_is_large_volume(struct disk_info* info);
 int disk_cyl_from_blocknum(blocknum_t blocknum, struct disk_info* info);
 int disk_head_from_blocknum(blocknum_t blocknum, struct disk_info* info);
 int disk_sec_from_blocknum(blocknum_t blocknum, struct disk_info* info);
Index: s390-tools-sles11/zipl/src/Makefile
===================================================================
--- s390-tools-sles11.orig/zipl/src/Makefile
+++ s390-tools-sles11/zipl/src/Makefile
@@ -11,8 +11,8 @@ includes = $(wildcard ../include/*.h)
 
 all: zipl
 
-zipl: ../boot/data.c $(objects)
-	$(CC) $(objects) -o zipl
+zipl: $(objects)
+	$(CC) -Wl,-z,noexecstack $(objects) ../boot/data.o -o zipl
 
 %.o: %.c $(includes) Makefile
 	$(CC) $(CFLAGS) -c -o $@ $<
@@ -29,5 +29,4 @@ clean:
 
 # Additional manual dependencies
 
-boot.o: ../boot/data.c
-
+boot.o: ../boot/data.o ../boot/data.h
Index: s390-tools-sles11/zipl/src/boot.c
===================================================================
--- s390-tools-sles11.orig/zipl/src/boot.c
+++ s390-tools-sles11/zipl/src/boot.c
@@ -19,8 +19,11 @@
 #include "misc.h"
 #include "zt_common.h"
 
-/* Include boot data */
-#include "../boot/data.c"
+/* Include declarations for boot_data symbols. */
+#include "../boot/data.h"
+
+#define DATA_SIZE(x)	((size_t) (&_binary_##x##_bin_size))
+#define DATA_ADDR(x)	(&_binary_##x##_bin_start)
 
 #define STAGE2_MAX_SIZE		4096
 
@@ -30,25 +33,25 @@
 int
 boot_check_data(void)
 {
-	if (sizeof(boot_data_fba0) !=
+	if (DATA_SIZE(fba0) !=
 	    sizeof(struct boot_fba_stage0)) {
 		error_reason("Size mismatch of stage 0 loader for disks with "
 			     "FBA layout");
 		return -1;
 	}
-	if (sizeof(boot_data_eckd0) !=
+	if (DATA_SIZE(eckd0) !=
 	    sizeof(struct boot_eckd_stage0)) {
 		error_reason("Size mismatch of stage 0 loader for disks with "
 			     "ECKD layout");
 		return -1;
 	}
-	if (sizeof(boot_data_eckd1a) !=
+	if (DATA_SIZE(eckd1a) !=
 	    sizeof(struct boot_eckd_classic_stage1)) {
 		error_reason("Size mismatch of stage 1 loader for disks with "
 			     "ECKD classic layout");
 		return -1;
 	}
-	if (sizeof(boot_data_eckd1b) !=
+	if (DATA_SIZE(eckd1b) !=
 	    sizeof(struct boot_eckd_compatible_stage1)) {
 		error_reason("Size mismatch of stage 1 loader for disks with "
 			     "ECKD compatible layout");
@@ -75,7 +78,7 @@ boot_get_stage3(void** buffer, size_t* b
 		return -1;
 	}
 	/* Get memory */
-	data = misc_malloc(sizeof(boot_data_stage3));
+	data = misc_malloc(DATA_SIZE(stage3));
 	if (data == NULL)
 		return -1;
 	/* Prepare params section */
@@ -85,10 +88,10 @@ boot_get_stage3(void** buffer, size_t* b
 	params.load_psw = (uint64_t) (image_addr | PSW_LOAD);
 	params.extra_parm = (uint64_t) extra_parm;
 	/* Initialize buffer */
-	memcpy(data, boot_data_stage3, sizeof(boot_data_stage3));
+	memcpy(data, DATA_ADDR(stage3), DATA_SIZE(stage3));
 	memcpy(data, &params, sizeof(struct boot_stage3_params));
 	*buffer = data;
-	*bytecount = sizeof(boot_data_stage3);
+	*bytecount = DATA_SIZE(stage3);
 	return 0;
 }
 
@@ -103,7 +106,7 @@ boot_init_fba_stage0(struct boot_fba_sta
 	blocknum_t i;
 
 	/* Initialize stage 0 data */
-	memcpy(stage0, boot_data_fba0, sizeof(struct boot_fba_stage0));
+	memcpy(stage0, DATA_ADDR(fba0), sizeof(struct boot_fba_stage0));
 	/* Fill in blocklist for stage 2 loader */
 	if (stage2_count > 8) {
 		error_reason("Not enough room for FBA stage 2 loader "
@@ -123,7 +126,7 @@ boot_init_fba_stage0(struct boot_fba_sta
 void
 boot_init_eckd_classic_stage0(struct boot_eckd_stage0* stage0)
 {
-	memcpy(stage0, boot_data_eckd0, sizeof(struct boot_eckd_stage0));
+	memcpy(stage0, DATA_ADDR(eckd0), sizeof(struct boot_eckd_stage0));
 	/* Fill in size of stage 1 loader */
 	stage0->read.count = sizeof(struct boot_eckd_classic_stage1);
 }
@@ -132,7 +135,7 @@ boot_init_eckd_classic_stage0(struct boo
 void
 boot_init_eckd_compatible_stage0(struct boot_eckd_stage0* stage0)
 {
-	memcpy(stage0, boot_data_eckd0, sizeof(struct boot_eckd_stage0));
+	memcpy(stage0, DATA_ADDR(eckd0), sizeof(struct boot_eckd_stage0));
 	/* Fill in size of stage 1 loader */
 	stage0->read.count = sizeof(struct boot_eckd_compatible_stage1);
 }
@@ -148,7 +151,7 @@ boot_init_eckd_classic_stage1(struct boo
 {
 	blocknum_t i;
 
-	memcpy(stage1, boot_data_eckd1a,
+	memcpy(stage1, DATA_ADDR(eckd1a),
 	       sizeof(struct boot_eckd_classic_stage1));
 	/* Fill in blocklist for stage 2 loader */
 	if (stage2_count > 8) {
@@ -159,7 +162,8 @@ boot_init_eckd_classic_stage1(struct boo
 	for (i=0; i < stage2_count; i++) {
 		stage1->ssrt[i].read.count 	= stage2_list[i].chs.size;
 		stage1->seek[i].cyl		= stage2_list[i].chs.cyl;
-		stage1->seek[i].head		= stage2_list[i].chs.head;
+		stage1->seek[i].head		= stage2_list[i].chs.head |
+			((stage2_list[i].chs.cyl >> 12) & 0xfff0);
 		stage1->seek[i].sec		= stage2_list[i].chs.sec;
 		stage1->ssrt[i].read.address_lo	= ZIPL_STAGE2_LOAD_ADDRESS +
 						  i * stage2_list[i].chs.size;
@@ -179,9 +183,9 @@ boot_init_eckd_classic_dump_stage1(struc
 	blocknum_t blocks;
 	blocknum_t i;
 
-	memcpy(stage1, boot_data_eckd1a,
+	memcpy(stage1, DATA_ADDR(eckd1a),
 	       sizeof(struct boot_eckd_classic_stage1));
-	blocks = (sizeof(boot_data_eckd2dump) +
+	blocks = (DATA_SIZE(eckd2dump) +
 			info->phy_block_size - 1) / info->phy_block_size;
 	if (blocks > 8) {
 		error_reason("Not enough room for ECKD stage 2 dump record "
@@ -190,13 +194,16 @@ boot_init_eckd_classic_dump_stage1(struc
 	}
 	/* Fill in block list of stage 2 dump record */
 	for (i=0; i < blocks; i++) {
+		int cyl;
+
 		stage1->ssrt[i].read.count = info->phy_block_size;
 		stage1->ssrt[i].read.address_lo = ZIPL_STAGE2_LOAD_ADDRESS +
 						  i * info->phy_block_size;
-		stage1->seek[i].cyl =
-			disk_cyl_from_blocknum(i + info->geo.start, info);
+		cyl = disk_cyl_from_blocknum(i + info->geo.start, info);
+		stage1->seek[i].cyl = cyl;
 		stage1->seek[i].head =
-			disk_head_from_blocknum(i + info->geo.start, info);
+			disk_head_from_blocknum(i + info->geo.start, info) |
+			((cyl >> 12) & 0xfff0);
 		stage1->seek[i].sec =
 			disk_sec_from_blocknum(i + info->geo.start, info);
 	}
@@ -213,7 +220,7 @@ boot_init_eckd_compatible_stage1(struct 
 	blocknum_t blocks;
 	blocknum_t i;
 
-	memcpy(stage1, boot_data_eckd1b,
+	memcpy(stage1, DATA_ADDR(eckd1b),
 	       sizeof(struct boot_eckd_compatible_stage1));
 	/* Fill in blocklist for stage 2 loader */
 	blocks = (STAGE2_MAX_SIZE + info->phy_block_size - 1) /
@@ -246,7 +253,7 @@ boot_get_tape_ipl(void** data, size_t* s
 			     "addressing mode)");
 		return -1;
 	}
-	buffer = misc_malloc(sizeof(boot_data_tape0));
+	buffer = misc_malloc(DATA_SIZE(tape0));
 	if (buffer == NULL)
 		return -1;
 	/* Prepare params section */
@@ -254,11 +261,11 @@ boot_get_tape_ipl(void** data, size_t* s
 	params.initrd_addr = (uint64_t) initrd_addr;
 	params.load_psw = (uint64_t) (image_addr | PSW_LOAD);
 	/* Initialize buffer */
-	memcpy(buffer, boot_data_tape0, sizeof(boot_data_tape0));
+	memcpy(buffer, DATA_ADDR(tape0), DATA_SIZE(tape0));
 	memcpy(VOID_ADD(buffer, BOOT_TAPE_IPL_PARAMS_OFFSET), &params,
 	       sizeof(struct boot_tape_ipl_params));
 	*data = buffer;
-	*size = sizeof(boot_data_tape0);
+	*size = DATA_SIZE(tape0);
 	return 0;
 }
 
@@ -272,13 +279,13 @@ boot_init_eckd_compatible_dump_stage1(
 	blocknum_t blocks;
 	blocknum_t i;
 
-	memcpy(stage1, boot_data_eckd1b,
+	memcpy(stage1, DATA_ADDR(eckd1b),
 	       sizeof(struct boot_eckd_compatible_stage1));
 	if (mvdump_switch)
-		blocks = (sizeof(boot_data_eckd2mvdump) +
+		blocks = (DATA_SIZE(eckd2mvdump) +
 			  info->phy_block_size - 1) / info->phy_block_size;
 	else
-		blocks = (sizeof(boot_data_eckd2dump) +
+		blocks = (DATA_SIZE(eckd2dump) +
 			  info->phy_block_size - 1) / info->phy_block_size;
 	if (blocks > 12) {
 		error_reason("Not enough room for ECKD stage 2 dump record "
@@ -471,9 +478,9 @@ boot_get_fba_stage2(void** data, size_t*
 	buffer = misc_malloc(STAGE2_MAX_SIZE);
 	if (buffer == NULL)
 		return -1;
-	memcpy(buffer, boot_data_fba2, sizeof(boot_data_fba2));
-	rc = store_stage2_menu(VOID_ADD(buffer, sizeof(boot_data_fba2)),
-			       STAGE2_MAX_SIZE - sizeof(boot_data_fba2),
+	memcpy(buffer, DATA_ADDR(fba2), DATA_SIZE(fba2));
+	rc = store_stage2_menu(VOID_ADD(buffer, DATA_SIZE(fba2)),
+			       STAGE2_MAX_SIZE - DATA_SIZE(fba2),
 			       job);
 	if (rc) {
 		free(buffer);
@@ -494,9 +501,9 @@ boot_get_eckd_stage2(void** data, size_t
 	buffer = misc_malloc(STAGE2_MAX_SIZE);
 	if (buffer == NULL)
 		return -1;
-	memcpy(buffer, boot_data_eckd2, sizeof(boot_data_eckd2));
-	rc = store_stage2_menu(VOID_ADD(buffer, sizeof(boot_data_eckd2)),
-			       STAGE2_MAX_SIZE - sizeof(boot_data_eckd2),
+	memcpy(buffer, DATA_ADDR(eckd2), DATA_SIZE(eckd2));
+	rc = store_stage2_menu(VOID_ADD(buffer, DATA_SIZE(eckd2)),
+			       STAGE2_MAX_SIZE - DATA_SIZE(eckd2),
 			       job);
 	if (rc) {
 		free(buffer);
@@ -513,15 +520,15 @@ boot_get_tape_dump(void** data, size_t* 
 {
 	void* buffer;
 
-	buffer = misc_malloc(sizeof(boot_data_tapedump));
+	buffer = misc_malloc(DATA_SIZE(tapedump));
 	if (buffer == NULL)
 		return -1;
-	memcpy(buffer, boot_data_tapedump, sizeof(boot_data_tapedump));
+	memcpy(buffer, DATA_ADDR(tapedump), DATA_SIZE(tapedump));
 	/* Write mem size to end of dump record */
-	memcpy(VOID_ADD(buffer, sizeof(boot_data_tapedump) - sizeof(mem)), &mem,
+	memcpy(VOID_ADD(buffer, DATA_SIZE(tapedump) - sizeof(mem)), &mem,
 	       sizeof(mem));
 	*data = buffer;
-	*size = sizeof(boot_data_tapedump);
+	*size = DATA_SIZE(tapedump);
 	return 0;
 }
 
@@ -531,15 +538,15 @@ boot_get_eckd_dump_stage2(void** data, s
 {
 	void* buffer;
 
-	buffer = misc_malloc(sizeof(boot_data_eckd2dump));
+	buffer = misc_malloc(DATA_SIZE(eckd2dump));
 	if (buffer == NULL)
 		return -1;
-	memcpy(buffer, boot_data_eckd2dump, sizeof(boot_data_eckd2dump));
+	memcpy(buffer, DATA_ADDR(eckd2dump), DATA_SIZE(eckd2dump));
 	/* Write mem size to end of dump record */
-	memcpy(VOID_ADD(buffer, sizeof(boot_data_eckd2dump) - sizeof(mem)),
+	memcpy(VOID_ADD(buffer, DATA_SIZE(eckd2dump) - sizeof(mem)),
 	       &mem, sizeof(mem));
 	*data = buffer;
-	*size = sizeof(boot_data_eckd2dump);
+	*size = DATA_SIZE(eckd2dump);
 	return 0;
 }
 
@@ -549,22 +556,22 @@ boot_get_eckd_mvdump_stage2(void** data,
 {
 	void* buffer;
 
-	buffer = misc_malloc(sizeof(boot_data_eckd2mvdump));
+	buffer = misc_malloc(DATA_SIZE(eckd2mvdump));
 	if (buffer == NULL)
 		return -1;
-	memcpy(buffer, boot_data_eckd2mvdump, sizeof(boot_data_eckd2mvdump));
+	memcpy(buffer, DATA_ADDR(eckd2mvdump), DATA_SIZE(eckd2mvdump));
 	/* Write mem size and force indicator (as specified by zipl -M)
 	 * to end of dump record, right before 512-byte parameter table */
-	memcpy(VOID_ADD(buffer, sizeof(boot_data_eckd2mvdump) - sizeof(mem) -
+	memcpy(VOID_ADD(buffer, DATA_SIZE(eckd2mvdump) - sizeof(mem) -
 			sizeof(struct mvdump_parm_table)), &mem, sizeof(mem));
-	memcpy(VOID_ADD(buffer, sizeof(boot_data_eckd2mvdump) - sizeof(mem) -
+	memcpy(VOID_ADD(buffer, DATA_SIZE(eckd2mvdump) - sizeof(mem) -
 			sizeof(force) - sizeof(struct mvdump_parm_table)),
 	       &force, sizeof(force));
-	memcpy(VOID_ADD(buffer, sizeof(boot_data_eckd2mvdump) -
+	memcpy(VOID_ADD(buffer, DATA_SIZE(eckd2mvdump) -
 			sizeof(struct mvdump_parm_table)), &parm,
 	       sizeof(struct mvdump_parm_table));
 	*data = buffer;
-	*size = sizeof(boot_data_eckd2mvdump);
+	*size = DATA_SIZE(eckd2mvdump);
 	return 0;
 }
 
@@ -574,14 +581,14 @@ boot_get_fba_dump_stage2(void** data, si
 {
 	void* buffer;
 
-	buffer = misc_malloc(sizeof(boot_data_fba2dump));
+	buffer = misc_malloc(DATA_SIZE(fba2dump));
 	if (buffer == NULL)
 		return -1;
-	memcpy(buffer, boot_data_fba2dump, sizeof(boot_data_fba2dump));
+	memcpy(buffer, DATA_ADDR(fba2dump), DATA_SIZE(fba2dump));
 	/* Write mem size to end of dump record */
-	memcpy(VOID_ADD(buffer, sizeof(boot_data_fba2dump) - sizeof(mem)),
+	memcpy(VOID_ADD(buffer, DATA_SIZE(fba2dump) - sizeof(mem)),
 	       &mem, sizeof(mem));
 	*data = buffer;
-	*size = sizeof(boot_data_fba2dump);
+	*size = DATA_SIZE(fba2dump);
 	return 0;
 }
Index: s390-tools-sles11/zipl/src/bootmap.c
===================================================================
--- s390-tools-sles11.orig/zipl/src/bootmap.c
+++ s390-tools-sles11/zipl/src/bootmap.c
@@ -104,7 +104,8 @@ bootmap_store_blockptr(void* buffer, dis
 		case disk_type_eckd_compatible:
 			eckd = (struct eckd_blockptr *) buffer;
 			eckd->cyl = ptr->chs.cyl;
-			eckd->head = ptr->chs.head;
+			eckd->head = ptr->chs.head |
+				     ((ptr->chs.cyl >> 12) & 0xfff0);
 			eckd->sec = ptr->chs.sec;
 			eckd->size = ptr->chs.size;
 			eckd->blockct = ptr->chs.blockct;
Index: s390-tools-sles11/zipl/src/disk.c
===================================================================
--- s390-tools-sles11.orig/zipl/src/disk.c
+++ s390-tools-sles11/zipl/src/disk.c
@@ -216,7 +216,7 @@ out_close:
 	close(fd);
 	free(data);
 	return -1;
-	
+
 }
 
 
@@ -509,6 +509,16 @@ disk_get_type_name(disk_type_t type)
 }
 
 
+/* Return non-zero for ECKD large volumes. */
+int
+disk_is_large_volume(struct disk_info* info)
+{
+	return (info->type == disk_type_eckd_classic ||
+	        info->type == disk_type_eckd_compatible) &&
+		info->geo.cylinders == 0xfffe;
+}
+
+
 /* Print textual representation of INFO contents. */
 void
 disk_print_info(struct disk_info* info)
@@ -544,8 +554,14 @@ disk_print_info(struct disk_info* info)
 	       info->geo.heads);
 	printf("  Geometry - sectors..............: %d\n",
 	       info->geo.sectors);
-	printf("  Geometry - cylinders............: %d\n",
-	       info->geo.cylinders);
+	if (disk_is_large_volume(info)) {
+		/* ECKD large volume. There is not enough information
+		 * available in INFO to calculate disk cylinder size. */
+		printf("  Geometry - cylinders............: > 65534\n");
+	} else {
+		printf("  Geometry - cylinders............: %d\n",
+		       info->geo.cylinders);
+	}
 	printf("  Geometry - start................: %ld\n",
 	       info->geo.start);
 	if (info->fs_block_size >= 0)
@@ -732,7 +748,7 @@ disk_get_blocklist_from_file(const char*
 }
 
 /* Check whether input device is in subchannel set 0.
- * Path to "dev" attribute containing the major/minor number depends on 
+ * Path to "dev" attribute containing the major/minor number depends on
  * whether option CONFIG_SYSFS_DEPRECATED is set or not */
 
 int disk_check_subchannel_set(int devno, dev_t device, char* dev_name)
Index: s390-tools-sles11/zipl/src/install.c
===================================================================
--- s390-tools-sles11.orig/zipl/src/install.c
+++ s390-tools-sles11/zipl/src/install.c
@@ -645,20 +645,46 @@ overwrite_partition_start(int fd, struct
 	return 0;
 }
 
+
+static int check_partition_bounds(struct disk_info* info)
+{
+	unsigned long long end_blk = info->geo.start + info->phy_blocks - 1;
+
+	if (end_blk > UINT32_MAX) {
+		error_reason("partition end exceeds bounds (offset "
+			     "%lld MB, max %lld MB)",
+			(end_blk * info->phy_block_size) >> 20,
+			(((unsigned long long) UINT32_MAX) *
+				info->phy_block_size) >> 20);
+		return -1;
+	}
+	return 0;
+}
+
 struct eckd_dump_param {
-	uint16_t	cyl;
-	uint16_t	head;
-	uint8_t		sec;
+	uint32_t	start_blk;
+	uint32_t	end_blk;
 	uint16_t	blocksize;
 	uint8_t		num_heads;
+	uint8_t		bpt;
+	char		reserved[4];
 } __attribute((packed));
 
+static void eckd_dump_store_param(struct eckd_dump_param* param,
+				  struct disk_info* info)
+{
+	param->start_blk = info->geo.start;
+	param->end_blk = info->geo.start + info->phy_blocks - 1;
+	param->num_heads = info->geo.heads;
+	param->blocksize = info->phy_block_size;
+	param->bpt = disk_sec_from_blocknum(param->end_blk, info);
+}
+
 static int
 install_dump_eckd_classic(int fd, struct disk_info* info, uint64_t mem)
 {
 	struct boot_eckd_stage0 stage0;
 	struct boot_eckd_classic_stage1 stage1;
-	struct eckd_dump_param* param;
 	void* buffer;
 	size_t size;
 	int rc;
@@ -676,22 +702,8 @@ install_dump_eckd_classic(int fd, struct
 	rc = boot_init_eckd_classic_dump_stage1(&stage1, info);
 	if (rc)
 		return rc;
-	/* Fill in start of dump partition */
-	param = (struct eckd_dump_param *) &stage1.param1;
-	param->cyl = disk_cyl_from_blocknum(info->geo.start, info);
-	param->head = disk_head_from_blocknum(info->geo.start, info);
-	param->sec = disk_sec_from_blocknum(info->geo.start, info);
-	param->blocksize = info->phy_block_size;
-	param->num_heads = info->geo.heads;
-	/* Fill in end of dump partition. Note that on ECKD devices with
-	 * classic disk layout, there is exactly one partition so that the
-	 * end of the device equals the end of the partition. */
-	param = (struct eckd_dump_param *) &stage1.param2;
-	param->cyl = info->geo.cylinders - 1;
-	param->head = info->geo.heads - 1;
-	param->sec = info->geo.sectors;
-	param->blocksize = info->phy_block_size;
-	param->num_heads = 0; /* Unused */
+	/* Fill in dump partition parameter */
+	eckd_dump_store_param((struct eckd_dump_param *) &stage1.param1, info);
 	/* Install stage 1 */
 	if (lseek(fd, info->phy_block_size, SEEK_SET) !=
 	    info->phy_block_size) {
@@ -731,7 +743,6 @@ install_dump_eckd_compatible(int fd, str
 {
 	struct boot_eckd_stage0 stage0;
 	struct boot_eckd_compatible_stage1 stage1;
-	struct eckd_dump_param* param;
 	void* buffer;
 	size_t size;
 	int rc;
@@ -754,23 +765,8 @@ install_dump_eckd_compatible(int fd, str
 	rc = boot_init_eckd_compatible_dump_stage1(&stage1, info, 0);
 	if (rc)
 		return rc;
-	/* Fill in start of dump partition */
-	param = (struct eckd_dump_param *) &stage1.param1;
-	param->cyl = disk_cyl_from_blocknum(info->geo.start, info);
-	param->head = disk_head_from_blocknum(info->geo.start, info);
-	param->sec = disk_sec_from_blocknum(info->geo.start, info);
-	param->blocksize = info->phy_block_size;
-	param->num_heads = info->geo.heads;
-	/* Fill in end of dump partition. */
-	param = (struct eckd_dump_param *) &stage1.param2;
-	param->cyl = disk_cyl_from_blocknum(info->geo.start +
-					    info->phy_blocks - 1, info);
-	param->head = disk_head_from_blocknum(info->geo.start +
-					      info->phy_blocks - 1, info);
-	param->sec = disk_sec_from_blocknum(info->geo.start +
-					    info->phy_blocks - 1, info);
-	param->blocksize	= info->phy_block_size;
-	param->num_heads	= 0; /* Unused */
+	/* Fill in dump partition parameter */
+	eckd_dump_store_param((struct eckd_dump_param *) &stage1.param1, info);
 	/* Install stage 1 */
 	if (lseek(fd, info->phy_block_size + 4, SEEK_SET) !=
 	    info->phy_block_size + 4) {
@@ -993,7 +989,6 @@ install_dump(const char* device, uint64_
 	if (rc) {
 		error_text("Could not get information for dump target "
 			   "'%s'", device);
-		close(fd);
 		return rc;
 	}
 	if (info->partnum == 0) {
@@ -1022,6 +1017,12 @@ install_dump(const char* device, uint64_
 	switch (info->type) {
 	case disk_type_eckd_classic:
 	case disk_type_eckd_compatible:
+		if (check_partition_bounds(info)) {
+			error_text("Dump target '%s'", device);
+			rc = -1;
+			break;
+		}
+		/* Fall through. */
 	case disk_type_fba:
 		part_size = info->phy_block_size * info->phy_blocks;
 		printf("Dump target: partition '%s' with a size of "
@@ -1044,9 +1045,13 @@ install_dump(const char* device, uint64_
 			rc = install_dump_fba(fd, info, mem);
 		break;
 	case disk_type_scsi:
+		error_reason("%s: Unsupported disk type '%s' (try --dumptofs)",
+			     device, disk_get_type_name(info->type));
+		rc = -1;
+		break;
 	case disk_type_diag:
-		error_reason("Unsupported disk type '%s' of dump target '%s'",
-			     disk_get_type_name(info->type), device);
+		error_reason("%s: Unsupported disk type '%s'",
+			     device, disk_get_type_name(info->type));
 		rc = -1;
 		break;
 	}
@@ -1074,14 +1079,14 @@ install_mvdump(char* const device[], int
 		fd = open(device[i], O_RDWR);
 		if (fd == -1) {
 			error_reason(strerror(errno));
-			error_text("Could not open dump target '%s'", 
+			error_text("Could not open dump target '%s'",
 				   device[i]);
 			rc = -1;
 			goto out;
 		}
 		if (rewind_tape(fd) == 0) {
 			/* Rewind worked - this is a tape */
-			error_text("Dump target '%s' is a tape device", 
+			error_text("Dump target '%s' is a tape device",
 				   device[i]);
 			close(fd);
 			rc = -1;
@@ -1121,9 +1126,14 @@ install_mvdump(char* const device[], int
 					       info[i]->device, device[i]);
 		if (rc)
 			goto out;
+		if (check_partition_bounds(info[i])) {
+			error_text("Dump target '%s'", device[i]);
+			rc = -1;
+			goto out;
+		}
 		parm.param[i].start_blk = info[i]->geo.start;
 		parm.param[i].end_blk = info[i]->geo.start +
-			info[i]->phy_blocks -1;
+					info[i]->phy_blocks - 1;
 		parm.param[i].end_sec =
 			disk_sec_from_blocknum(info[i]->geo.start +
 					       info[i]->phy_blocks - 1,
Index: s390-tools-sles11/zipl/src/zipl.c
===================================================================
--- s390-tools-sles11.orig/zipl/src/zipl.c
+++ s390-tools-sles11/zipl/src/zipl.c
@@ -90,8 +90,8 @@ print_usage(void)
 static void
 print_version(void)
 {
-	printf("%s version %s.\n", tool_name, RELEASE_STRING);
-	printf("%s.\n", copyright_notice);
+	printf("%s version %s\n", tool_name, RELEASE_STRING);
+	printf("%s\n", copyright_notice);
 }
 
 
